
#define MAXCONN 100
#define MAXCHAN 20 
#define MAX_USER_THREADS 4 
#define MAINCHANNEL "Main"
#define DEFAULT_PORT 6666
#define GC_TIME 300 
#define MAX_USER_NAME_LENGTH 17 
#define EMOTE_CHAR '%'
#define BAD_WORD_BUFFER_SIZE 1024
#define BANS_BUFFER_SIZE 4096
#define ALLOWS_BUFFER_SIZE 4096
#define WHO_BUFFER_SIZE 250
#define MAX_MESSAGE_SIZE 512
#define CHANNEL_NAME_LEN 20

#define CAN_BE_NOTHING 1
#define NOT_USERID 2

#ifdef WINDOWS
#define CONFIGDIR1 "c:\\Program Files\\nakenchat\\"
#define CONFIGDIR2 "c:\\nakenchat\\"
#else
#define CONFIGDIR1 "/usr/local/etc/"
#define CONFIGDIR2 "/etc/"
#endif

#ifdef WINDOWS
#define SHUT_RDWR SD_BOTH
#endif

/* YOU MAY NOT EDIT THESE NEXT TWO LINES OF CODE */
#define VERSION "Naken Chat 2.12 - June 28, 2007"
#define COPYRIGHT "Copyright 1998-2007 Michael Kohn"
/* NAKEN CHAT IS NOT GPL */

struct User
{
  char location[64];
  char username[MAX_USER_NAME_LENGTH+1];
  char outString[MAX_MESSAGE_SIZE+2];
  unsigned char buffer[MAX_MESSAGE_SIZE+2];
  unsigned char *gags;
  int ID,r;
  int channel,uflags;
  time_t logontime,idletime,stamptime;
  char user_level,inuse;
  int spam,lastp;
  int socketid;
  int bptr,blen,ptr;
  int warnings;
  FILE *socketfd;
  char emote_char;
};

extern int sockfd,bancount,allowcount,badwordcount,port;
extern struct User nulluser; 
extern struct User **users; 
extern char channels[MAXCHAN][CHANNEL_NAME_LEN];
extern int channelop[MAXCHAN];
extern int cflags[MAXCHAN];
extern int international,debug,censor;
extern unsigned int uptime;
extern unsigned int serverflags;
extern char sysoppw[15];
extern char bans[BANS_BUFFER_SIZE];
extern char allows[ALLOWS_BUFFER_SIZE];
extern char badword[BAD_WORD_BUFFER_SIZE];
extern char welcome[2048];
extern char logfile[256];
#ifdef WHOFILE
extern char whofile[256];
#ifdef WINDOWS
extern CRITICAL_SECTION win_mutex;
#else
extern pthread_mutex_t pthread_mutex;
extern pthread_mutexattr_t pthread_mutexattr;
#endif
#endif
extern char passwd[256];
extern char configdir[256];
extern int welcomelen;
extern int logging;
extern int login_speed;
extern int maxconn;
extern int minconn;
extern time_t max_idle_time;
extern FILE *logfp;

/*

Server Flags

0: channel disallow   (1)
1: host lookups       (2)
2: show ips           (4)
3: no dup ips         (8)
4: elite mode         (16)
5: force password     (32)
6: force names        (64)
7: no duplicate names (128)
8: no name changing   (256)
9: kick dups          (512)

*/

/*

User Flags
0: Beeps
1: Hilites
2: Squelched
3: Hush Yells
4: Echos
5: Time Stamping
6: System Messages
7: Hidden Sysop
8: Client Userlist
9: User already changed their name

*/


