#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#ifndef WINDOWS
#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <netdb.h>
#ifndef NO_CRYPT_DOT_H
#include <crypt.h>
#endif
#endif
#include <errno.h>
#include <time.h>
#include <ctype.h>
#ifdef WINDOWS
#include <windows.h>
#endif

#include "globals.h"
#include "functions.h"
#include "language.h"

void message(int ID, char *daMessage, int att)
{
char newMessage[2048];
char tempMessage[2048];
time_t ti;

  if (users[ID]->inuse!=1 && users[ID]->inuse!=100) return;
  if (att==1)
  {
    if ((users[ID]->uflags&1)!=0)
    { sprintf(newMessage,"%c%s",(char)7,daMessage); }
      else
    { strcpy(newMessage,daMessage); }

    if ((users[ID]->uflags&2)!=0)
    { 
      sprintf(tempMessage,"%c[1m%s%c[0m",(char)27,newMessage,(char)27);
      strcpy(newMessage,tempMessage);
    }

    if ((users[ID]->uflags&32)!=0 && time(NULL)-users[ID]->stamptime>600)
    { 
      ti=time(NULL);
      sprintf(tempMessage,">> %s\r",ctime((time_t*)&ti));
      strcat(newMessage,tempMessage);
      users[ID]->stamptime=time(NULL);
    }

#ifdef LEET
    if ((serverflags&16)==16)
    { leet(newMessage); }
#endif

    if (send(users[ID]->socketid,newMessage,strlen(newMessage),0)<=0)
    {
      users[ID]->inuse=2;
      kill_user(ID);
    }
  }
    else
  { 
    if ((users[ID]->uflags&32)!=0 && time(NULL)-users[ID]->stamptime>600)
    { 
      ti=time(NULL);
      sprintf(newMessage,"%s>> %s\r",daMessage,ctime((time_t*)&ti));

#ifdef LEET
      if ((serverflags&16)==16)
      { leet(newMessage); }
#endif

      users[ID]->stamptime=time(NULL);
      if (send(users[ID]->socketid,newMessage,strlen(newMessage),0)<=0)
      {
        users[ID]->inuse=2;
        kill_user(ID);
      }
    }
      else
    {
#ifdef LEET
      strcpy(newMessage,daMessage);

      if ((serverflags&16)==16)
      { leet(newMessage); }

      if (send(users[ID]->socketid,newMessage,strlen(newMessage),0)<=0)
      {
        users[ID]->inuse=2;
        kill_user(ID);
      }
#else
      if (send(users[ID]->socketid,daMessage,strlen(daMessage),0)<=0)
      {
        users[ID]->inuse=2;
        kill_user(ID);
      }
#endif
    }
  }
}

void sendpriv(int ID, int OID, char *daMessage)
{
char tempString[MAX_MESSAGE_SIZE+128];

#ifdef DEBUG
  if (debug==1) printf("TO: %d FROM: %d  MESSAGE: %s\n",ID,OID,daMessage);
#endif
  if (logging==1) 
  {
    fprintf(logfp,"TO: %d %s FROM: %d %s  MESSAGE: %s",ID,users[ID]->username,
         OID,users[OID]->username,daMessage);
    fflush(logfp);
  }

  if (ID<maxconn)
  {
    if (users[ID]->inuse==1)
    {
      message(ID,daMessage,1);
      if ((users[OID]->uflags&16)==0)
      { sprintf(tempString,PRIVATE,ID,users[ID]->username); }
	else
      { sprintf(tempString,PRIVATE_ECHO,ID,users[ID]->username,daMessage); }
      message(OID,tempString,0);
    }
      else
    { message(OID,NOT_HERE,0); }
  }
    else
  { message(OID,NOT_HERE,0); }
}

void sendchan(int ID, int channel, char *daMessage)
{
int r;

  if (logging==1) 
  { 
    fprintf(logfp,"[%s]",channels[channel]); 
    fprintf(logfp,"%s",daMessage); 
    fflush(logfp);
  }

  for (r=0; r<maxconn; r++)
  {
    if (users[r]->inuse==1 && users[r]->channel==channel) 
    {
      if (ID==-1) message(r,daMessage,0);
	else
      if ((users[r]->gags[ID/8]&(1<<(ID%8)))==0) 
      { 
        if (users[r]->user_level<10 && (users[ID]->user_level==10 && (users[ID]->uflags&128)!=0))
        { continue; }
        message(r,daMessage,0);
      }
    }
  }
}

void yell(int ID, char *daMessage)
{
int r;

  if (logging==1) 
  { 
    fprintf(logfp,"%s",daMessage); 
    fflush(logfp);
  }

  for(r=0; r<maxconn; r++)
  {
    if(users[r]->inuse==1)
    {
      if ((users[r]->gags[ID/8]&(1<<(ID%8)))==0)
	if ((users[r]->uflags&8)==0) message(r,daMessage,0);
    }
  }
}

void sendchanbut(int ID, int channel, char *daMessage)
{
int r;

  if (logging==1) 
  { 
    fprintf(logfp,"[%s]",channels[channel]); 
    fprintf(logfp,"%s",daMessage); 
    fflush(logfp);
  }

  for (r=0; r<maxconn; r++)
  {
    if ((users[r]->inuse==1 && users[r]->channel==channel) && 
        (r!=ID && (users[r]->uflags&64)==0)) 
    { 
      if (users[r]->user_level<10 && (users[ID]->user_level==10 && (users[ID]->uflags&128)!=0))
      { continue; }
      message(r,daMessage,0); 
    }
  }
}

void sendall(int ID, char *daMessage)
{
int r;

  if (logging==1) 
  { 
    fprintf(logfp,"%s",daMessage); 
    fflush(logfp);
  }

  for (r=0; r<maxconn; r++)
  {
    if (users[r]->inuse==1)
    {
      if (ID==-1) message(r,daMessage,0);
	else
      if ((users[r]->gags[ID/8]&(1<<(ID%8)))==0 && (users[r]->uflags&64)==0) 
      {
        if (users[r]->user_level<10 && (users[ID]->user_level==10 && (users[ID]->uflags&128)!=0))
        { continue; }

        message(r,daMessage,0);
      }
    }
  }
}

void sendallbut(int ID, char *daMessage)
{
int r;

  if (logging==1) 
  { 
    fprintf(logfp,"%s",daMessage); 
    fflush(logfp);
  }

  for (r=0; r<maxconn; r++)
  {
    if (users[r]->inuse==1 && r!=ID)
    {
      if (ID==-1) message(r,daMessage,0);
	else
      if ((users[r]->gags[ID/8]&(1<<(ID%8)))==0 && (users[r]->uflags&64)==0) 
      {
        if (users[r]->user_level<10 && (users[ID]->user_level==10 && (users[ID]->uflags&128)!=0))
        { continue; }
        message(r,daMessage,0);
      }
    }
  }
}


