#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#ifndef WINDOWS
#include <sys/socket.h>
#include <netinet/in.h>
#include <pwd.h>
#include <grp.h>
#ifndef NO_CRYPT_DOT_H
#include <crypt.h>
#endif
#endif
#include <time.h>
#include <ctype.h>
#ifdef WINDOWS
#include <windows.h>
#endif

#include "globals.h"
#include "functions.h"
#include "language.h"

extern char help_message[sizeof(HELP)+sizeof(CHAN_HELP)+2];

void addtowelcome(char *s)
{
int t,l;

  l=strlen(s);

  for (t=0; t<l; t++)
  { 
    if (s[t]=='\n' || s[t]=='\r') break;
    if (s[t]<32) continue;
    welcome[welcomelen++]=s[t];
  }
  
  welcome[welcomelen++]='\n';
  welcome[welcomelen++]='\r';
  welcome[welcomelen]=0;
}

void read_config()
{
FILE *fp;
int r=0,w=0,t;
char name[100];
char *param;
char *badwordptr;
char *allowptr;
#ifndef WINDOWS
struct passwd *pw;
struct group *gr;
#endif

  allowcount=0;
  allowptr=allows;
  bancount=0;
  badwordcount=0;
  badwordptr=badword;
  welcomelen=0;
#ifdef WHOFILE
  whofile[0]=0;
#endif

  fp=fopen(configdir,"r");
 
  if (fp==0)
  { 
    printf("Couldn't open %s.  Trying "CONFIGDIR2"nakenchat.conf\n",configdir);

    strcpy(configdir,CONFIGDIR2"nakenchat.conf");
    fp=fopen(configdir,"r");

    if (fp==0)
    {
      printf("Couldn't open %s. Trying ./nakenchat\n",configdir);

      strcpy(configdir,"./nakenchat.conf");
      fp=fopen(configdir,"r");

      if (fp==0)
      {
        printf("No config file found.  Going with defaults.\n");
      }
    } 
  }

  if (fp!=0)
  {
    printf("Config File: %s\n",configdir);

    while(1)
    {
      t=0; r=0;
      param=0;
      
      while((w=getc(fp))!=EOF)
      {
        if (w=='\n' || w=='\r') break;
        if ((w==' ' || w=='\t') && r==0)
        {
          name[t++]=0;
          r=1;
        }
          else
        if (!(w==' ' || w=='\t') && r==1)
        {
          param=name+t;
          name[t++]=w;
          r=2;
        }
          else
        { name[t++]=w; }
      }

      name[t]=0;

      while(t>0 && (name[t-1]==' ' || name[t-1]=='\t'))
      { name[--t]=0; }

      if (w==EOF && t==0) break;
      if (param==0) param=name+t;
      if (t==0 || name[0]=='#') continue;

      w=0;
      if (strcasecmp(name,"SYSOP_PASSWORD")==0) w=1;
        else
      if (strcasecmp(name,"BAD_WORD")==0) w=2;
        else
      if (strcasecmp(name,"ALLOW")==0) w=3;
        else
      if (strcasecmp(name,"BAN")==0) w=4;
        else
      if (strcasecmp(name,"INTERNATIONAL")==0) w=5;
        else
      if (strcasecmp(name,"PORT")==0) w=6;
        else
      if (strcasecmp(name,"HOSTLOOKUPS")==0) w=7;
        else
      if (strcasecmp(name,"SHOWIPS")==0) w=8;
        else
      if (strcasecmp(name,"WELCOME")==0) addtowelcome(param);
        else
      if (strcasecmp(name,"NODUPIPS")==0) w=9;
        else
      if (strcasecmp(name,"LOGFILE")==0) w=10;
        else
      if (strcasecmp(name,"MAXCONN")==0) w=11;
        else
      if (strcasecmp(name,"MINCONN")==0) w=12;
        else
      if (strcasecmp(name,"MAX_IDLE_TIME")==0) w=13;
        else
      if (strcasecmp(name,"PASSWD")==0) w=14;
        else
      if (strcasecmp(name,"CENSOR")==0) w=15;
        else
      if (strcasecmp(name,"CHANNEL_DISABLE")==0) w=16;
        else
      if (strcasecmp(name,"LOGGING")==0) w=17;
        else
      if (strcasecmp(name,"FORCE_PASSWD")==0) w=18;
        else
      if (strcasecmp(name,"FORCE_NAME")==0) w=19;
        else
      if (strcasecmp(name,"NODUP_NAMES")==0) w=20;
        else
      if (strcasecmp(name,"NO_NAME_CHANGE")==0) w=21;
        else
      if (strcasecmp(name,"LOGIN_SPEED")==0) w=22;
        else
      if (strcasecmp(name,"WHO_FILE")==0) w=23;
        else
      if (strcasecmp(name,"KICK_DUPS")==0) w=24;
        else
      if (strcasecmp(name,"RUN_AS")==0) w=25;

      if (w!=0)
      { 

        if (w==1) safestrncpy(sysoppw,param,15);
          else
        if (w==2)
        {
          if (strlen(param)+badwordptr+1>=badword+BAD_WORD_BUFFER_SIZE)
          {
            printf("Exceeded %d bytes for bad words.  Cannot add word %s\n",BAD_WORD_BUFFER_SIZE,param);
          }
            else
          {
            strcpy(badwordptr,param);
            badwordptr=badwordptr+strlen(param)+1;
            badwordcount++;
          }
        }
          else
        if (w==3)
        {
          if (strlen(param)+allowptr+1>=allows+ALLOWS_BUFFER_SIZE)
          {
            printf("Exceeded %d bytes for allows.  Cannot add site %s\n",ALLOWS_BUFFER_SIZE,param);
          }
            else
          {
            strcpy(allowptr,param);
            allowptr=allowptr+strlen(param)+1;
            allowcount++;
          }
        }
          else
        if (w==4)
        {
          if (ban_address(param)==1)
          {
            printf("Exceeded %d bytes for bans.  Cannot add site %s\n",BANS_BUFFER_SIZE,param);
          }
        }
          else
       if (w==5) { if (atoi(param)==1) international=1; }
         else
       if (w==6) port=atoi(param);
          else
        if (w==7) 
        { if (atoi(param)==1) serverflags=serverflags|2; }
          else
        if (w==8) 
        { if (atoi(param)==1) serverflags=serverflags|4; }
          else
        if (w==9) 
        { if (atoi(param)==1) serverflags=serverflags|8; }
          else
        if (w==10) 
        { strcpy(logfile,param); }
          else
        if (w==11) maxconn=atoi(param);
          else
        if (w==12) minconn=atoi(param);
          else
        if (w==13) max_idle_time=atoi(param)*60;
          else
        if (w==14)
        { strcpy(passwd,param); }
          else
        if (w==15) censor=atoi(param);
          else
        if (w==16) 
        { if (atoi(param)==1) serverflags=serverflags|1; }
          else
        if (w==17) 
        { if (atoi(param)==1) logfile_on(-1); }
          else
        if (w==18) 
        { if (atoi(param)==1) serverflags=serverflags|32; }
          else
        if (w==19) 
        { if (atoi(param)==1) serverflags=serverflags|64; }
          else
	if (w==20) 
        { if (atoi(param)==1) serverflags=serverflags|128; }
          else
	if (w==21) 
        { if (atoi(param)==1) serverflags=serverflags|256; }
          else
        if (w==22) login_speed=atoi(param);
#ifdef WHOFILE
          else
        if (w==23)
        { strcpy(whofile,param); }
#endif
          else
        if (w==24)
        { if (atoi(param)==1) serverflags=serverflags|512; }
          else
        if (w==25)
        {
#ifndef WINDOWS
          t=0;
          while(param[t]!=':' && param[t]!=0) t++;

          if (param[t]==':')
          {
            param[t]=0;
            t++;
            gr=getgrnam(param+t);
            if (gr==0)
            { printf("No such group %s\n",param+t); }
              else
            if (setgid(gr->gr_gid)!=0)
            { printf("Couldn't set group %s\n",param+t); }
          }

          pw=getpwnam(param);

          if (pw==0)
          { printf("No such user %s\n",param); }
            else
          if (setuid(pw->pw_uid)!=0)
          { printf("Couldn't set user to %s\n",param); }
#else
          printf("RUN_AS is not supported on Windows\n");
#endif
        }
      }
    } 

    fclose(fp);
  }

  if (welcomelen==0)
  {
    strcpy(welcome,">> Naken Chat - Copyright 1998-2006 Michael Kohn\r\n\n\r");
    welcomelen=strlen(welcome);
    return;
  }

  sprintf(help_message,HELP,EMOTE_CHAR);

  if ((serverflags&1)==0)
  { strcat(help_message,CHAN_HELP); }
  /* { strcpy(&help_message[sizeof(HELP)-1],CHAN_HELP); } */

  strcat(help_message,"\r\n");
}

void setup(int argc, char *argv[])
{
char *allowptr;
char *banptr;
int r;

  port=DEFAULT_PORT;
  configdir[0]=0;

  for (r=1; r<argc; r++)
  {
    if (strcasecmp(argv[r],"-f")==0) 
    { strcpy(configdir,argv[++r]); break; }
  }

  logfile[0]=0;
  passwd[0]=0;

  if (configdir[0]==0)
  {
     strcpy(configdir,CONFIGDIR1"nakenchat.conf");
  }

  strcpy(channels[0],MAINCHANNEL);
  strcpy(sysoppw,"password");
  uptime=time(NULL);
  srand(uptime);

  read_config();

  if (logfile[0]!=0) printf("Logfile: %s\n",logfile);

  printf("Currently banned sites:\n");
  banptr=bans;
  for (r=0; r<bancount; r++)
  {
    printf("%d: %s\n",r,banptr);
    banptr=banptr+strlen(banptr)+1;
  }

  printf("%d bans found\n\n",bancount);

  if (allowcount!=0)
  {
    printf("Only these sites may logon:\n");
    allowptr=allows;
    for (r=0; r<allowcount; r++)
    {
      printf("%d: %s\n",r,allowptr);
      allowptr=allowptr+strlen(allowptr)+1;
    }
  }

  for (r=1; r<argc; r++)
  {
    if (strcmp(argv[r],"-p")==0)
    { port=atoi(argv[++r]); }
      else
    if (strcasecmp(argv[r],"-d")==0) debug=1;
  }
}

